<?php
/**
* The worldnet_hpp class, containing the payment processing code
* for transactions with WorldNet's Hosted Payment Page
*
* @copyright Copyright (C) 2010 WorldNet TPS - All rights reserved.
*/

$nzshpcrt_gateways[$num]['name'] = 'WorldNet HPP secure payments';
$nzshpcrt_gateways[$num]['internalname'] = 'worldnet_hpp';
$nzshpcrt_gateways[$num]['function'] = 'gateway_worldnet_hpp';
$nzshpcrt_gateways[$num]['form'] = 'form_worldnet_hpp';
$nzshpcrt_gateways[$num]['submit_function'] = 'submit_worldnet_hpp';

function form_worldnet_hpp() {
	$gateways = array("WorldNet" => "payments", "CashFlows" => "cashflows");
	$baseCurrencies = array("Euros" => "EUR", "Sterling" => "GBP", "US Dollars" => "USD");
	
	$gatewayString = "";
	foreach($gateways as $name => $code) $gatewayString .= '<option value="' . $code . '"' . ($code == get_option('worldnet_hpp_gateway') ? ' selected="selected"' : '') . '>' . $name . '</option>';

	$baseCurrencyString = "";
	foreach($baseCurrencies as $name => $code) $baseCurrencyString .= '<option value="' . $code . '"' . ($code == get_option('worldnet_hpp_terminal_currency') ? ' selected="selected"' : '') . '>' . $name . '</option>';
	
	$output  = '<tr><td>Gateway:</td><td><select name="worldnet_hpp_gateway">' . $gatewayString . '</select></td></tr>';
	$output .= '<tr><td>Test account?</td><td><input name="worldnet_hpp_test_account" type="checkbox" ' . (get_option('worldnet_hpp_test_account') ? 'checked="checked"' : '') . '/></td></tr>';
	$output .= '<tr><td>Terminal ID:</td><td><input name="worldnet_hpp_terminal_id" type="text" value="' . get_option('worldnet_hpp_terminal_id') . '" /></td></tr>';
	$output .= '<tr><td>Terminal Currency:</td><td><select name="worldnet_hpp_terminal_currency">' . $baseCurrencyString . '</select></td></tr>';
	$output .= '<tr><td>Shared Secret:</td><td><input name="worldnet_hpp_shared_secret" type="text" value="' . get_option('worldnet_hpp_shared_secret') . '" /></td></tr>';
	$output .= '<tr><td>Send WorldNet receipt to the customer?</td><td><input name="worldnet_hpp_send_email" type="checkbox" ' . (get_option('worldnet_hpp_send_email') ? 'checked="checked" ' : '') . '/></td></tr>';
	$output .= '<tr><td>Send billing address to the payment page (for AVS)?</td><td><input name="worldnet_hpp_send_address" type="checkbox" ' . (get_option('worldnet_hpp_send_address') ? 'checked="checked" ' : '') . '/></td></tr>';

	return $output;
}

function submit_worldnet_hpp() {
	update_option('worldnet_hpp_gateway', $_POST['worldnet_hpp_gateway']);
	
	if(isset($_POST['worldnet_hpp_test_account'])) update_option('worldnet_hpp_test_account', true);
	else update_option('worldnet_hpp_test_account', false);
	
	update_option('worldnet_hpp_terminal_id', $_POST['worldnet_hpp_terminal_id']);
	update_option('worldnet_hpp_terminal_currency', $_POST['worldnet_hpp_terminal_currency']);
	update_option('worldnet_hpp_shared_secret', $_POST['worldnet_hpp_shared_secret']);
	
	if(isset($_POST['worldnet_hpp_send_address'])) update_option('worldnet_hpp_send_address', true);
	else update_option('worldnet_hpp_send_address', false);
	
	if(isset($_POST['worldnet_hpp_send_email'])) update_option('worldnet_hpp_send_email', true);
	else update_option('worldnet_hpp_send_email', false);
	
	return true;
}

function gateway_worldnet_hpp($seperator, $sessionid) {
	global $wpdb, $wpsc_cart;
	
	$purchase_log = $wpdb->get_row("SELECT * FROM `" . WPSC_TABLE_PURCHASE_LOGS . "` WHERE `sessionid`= " . $sessionid . " LIMIT 1", ARRAY_A);
	
	$usersql = "SELECT `".WPSC_TABLE_SUBMITED_FORM_DATA."`.value, `".WPSC_TABLE_CHECKOUT_FORMS."`.`name`, `".WPSC_TABLE_CHECKOUT_FORMS."`.`unique_name` FROM `".WPSC_TABLE_CHECKOUT_FORMS."` LEFT JOIN `".WPSC_TABLE_SUBMITED_FORM_DATA."` ON `".WPSC_TABLE_CHECKOUT_FORMS."`.id = `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`form_id` WHERE `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`log_id`=".$purchase_log['id']." ORDER BY `".WPSC_TABLE_CHECKOUT_FORMS."`.`order`";
	$userinfo = $wpdb->get_results($usersql, ARRAY_A);
	
	$dateTime = date('d-m-Y:H:i:s:000');
	
	$receiptPageURL = get_option('transact_url') . $seperator . "sessionid=" . $sessionid . "&gateway=worldnet_hpp&process=return";
	$validationURL = get_option('transact_url') . $seperator . "&gateway=worldnet_hpp&process=validate";
	
	$data = array();
	$data['TERMINALID']		= get_option('worldnet_hpp_terminal_id');
	$data['ORDERID']		= $purchase_log['id'];
	$data['CURRENCY'] 		= get_option('worldnet_hpp_terminal_currency');
	$data['AMOUNT']			= number_format( $wpsc_cart->total_price ,2, '.', '');
	
	if(get_option('worldnet_hpp_send_email') || get_option('worldnet_hpp_send_address')) {
		$form_fields = $wpdb->get_results("SELECT `id`,`unique_name` FROM `".WPSC_TABLE_CHECKOUT_FORMS."` WHERE `active` = '1'",ARRAY_A);
		foreach((array)$form_fields as $field) {
			if(get_option('worldnet_hpp_send_email') && $field["unique_name"] == "billingemail") {
			  	$data['EMAIL'] = $_REQUEST['collected_data'][$field['id']];
			}
			if(get_option('worldnet_hpp_send_address')) {
				if($field["unique_name"] == "billingaddress") $data['ADDRESS1'] = $_REQUEST['collected_data'][$field['id']];
				if($field["unique_name"] == "billingcity") $data['ADDRESS2'] = $_REQUEST['collected_data'][$field['id']];
				if($field["unique_name"] == "billingpostcode") $data['POSTCODE'] = $_REQUEST['collected_data'][$field['id']];
			}
		}
	}

	$data['DATETIME']		= $dateTime;
	$data['RECEIPTPAGEURL']		= $receiptPageURL;
	$data['VALIDATIONURL']		= $validationURL;
	$data['HASH']			= md5(get_option('worldnet_hpp_terminal_id') . $purchase_log['id'] . number_format( $wpsc_cart->total_price ,2, '.', '') . $dateTime . $receiptPageURL . $validationURL . get_option('worldnet_hpp_shared_secret'));
	$data['WORDPRESSSESSIONID']	= $sessionid;
	
	$worldnetURL = "https://" . (get_option('worldnet_hpp_test_account') ? "test" : "") . get_option('worldnet_hpp_gateway') . ".worldnettps.com/merchant/paymentpage";
	
	echo "<div style='display: none'>\n<form id='worldnet_hpp_form' action='$worldnetURL' method='post'>\n";
	foreach($data as $key => $val) echo "<input type='hidden' name='$key' value='$val' />\n";
	echo "<input type='submit' value='Pay' /></form>\n</div>\n<script language='javascript' type='text/javascript'>document.getElementById('worldnet_hpp_form').submit();</script>";
	
	exit();
}

function catch_worldnet_hpp() {
	if($_REQUEST['gateway'] == 'worldnet_hpp' && $_REQUEST['process'] == 'return' && isset($_REQUEST['WORDPRESSSESSIONID']) && $_REQUEST['WORDPRESSSESSIONID'] != "") {
        	if($_REQUEST['RESPONSECODE'] == 'A') {
			if(strstr(get_option('transact_url'), "?")) $next_url = get_option('transact_url') . "&sessionid=" . $_REQUEST['WORDPRESSSESSIONID'];
			else $next_url = get_option('transact_url') . "?sessionid=" . $_REQUEST['WORDPRESSSESSIONID'];
		}
		else {
			if(strstr(get_option('transact_url'), "?")) $next_url = get_option('transact_url')."&act=error";
			else $next_url = get_option('transact_url')."?act=error";
		}
		
		header("Location: " . $next_url);
		exit();
   	}
}

function catch_worldnet_validation() {
	global $wpdb;
	if($_REQUEST['gateway'] == 'worldnet_hpp' && $_REQUEST['process'] == 'validate') {
		$terminalId = get_option('worldnet_hpp_terminal_id');
		$expectedResponseHash = md5($terminalId . $_REQUEST['ORDERID'] . $_REQUEST['AMOUNT'] . $_REQUEST['DATETIME'] . $_REQUEST['RESPONSECODE'] . $_REQUEST['RESPONSETEXT'] . get_option('worldnet_hpp_shared_secret'));
		
        	if($expectedResponseHash != $_REQUEST['HASH']) {
			$wpdb->query("UPDATE `" . WPSC_TABLE_PURCHASE_LOGS . "` SET `processed` = '1' WHERE `id` = " . $_REQUEST['ORDERID']);
			die("Hash mismatch for Order ID ".$_REQUEST['ORDERID'].", expected: ".$expectedResponseHash);
		} else {
			switch($_REQUEST['RESPONSECODE']) {
				case 'A':	$wpdb->query("UPDATE `" . WPSC_TABLE_PURCHASE_LOGS . "` SET `processed` = '3' WHERE `id` = " . $_REQUEST['ORDERID']);
						break;
				default:	$wpdb->query("UPDATE `" . WPSC_TABLE_PURCHASE_LOGS . "` SET `processed` = '6' WHERE `id` = " . $_REQUEST['ORDERID']);
			}
			die("OK");
		}
   	}
}

add_action('init', 'catch_worldnet_hpp');
add_action('init', 'catch_worldnet_validation');

?>
